package com.sckw.contract.controller;

import com.sckw.contract.model.vo.req.*;
import com.sckw.contract.service.*;
import com.sckw.core.exception.SystemException;
import com.sckw.core.model.enums.EntTypeEnum;
import com.sckw.core.web.constant.HttpStatus;
import com.sckw.core.web.response.HttpResult;
import jakarta.validation.Valid;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author czh
 * @desc 托运合同
 * @date 2023/7/13
 */
@RestController
@RequestMapping("kwcChecked")
public class KwcCheckedController {

    @Autowired
    private KwcContractLogisticsService kwcContractLogisticsService;

    /**
     * @desc 分页查询
     * @param reqVo 分页入参
     * @author czh
     * @date 2023/7/17
     * @return HttpResult
     */
    @RequestMapping("queryListByPage")
    public HttpResult queryListByPage(@RequestBody QueryListReqVo reqVo) throws SystemException {
        reqVo.setEntType(EntTypeEnum.LOGISTICS3.getCode());
        return HttpResult.ok(kwcContractLogisticsService.queryListByPage(reqVo));
    }

    /**
     * @param reqVo 新增入参
     * @return HttpResult
     * @desc 新增托运合同
     * @author czh
     * @date 2023/7/13
     */
    @RequestMapping("add")
    public HttpResult addCheckedContract(@RequestBody ContractLogisticsReqVo reqVo) throws SystemException {
        kwcContractLogisticsService.addCheckedContract(reqVo);
        return HttpResult.ok(HttpStatus.MSG_003);
    }

    /**
     * @param reqVo 补充入参
     * @desc: 补充合同
     * @author: czh
     * @date: 2023/7/14
     */
    @PostMapping("supplement")
    public HttpResult supplement(@Valid @RequestBody ContractLogisticsReqVo reqVo) throws SystemException {
        kwcContractLogisticsService.supplement(reqVo);
        return HttpResult.ok(HttpStatus.MSG_003);
    }

    /**
     * @desc: 合同详情
     * @param reqVo id
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("detail")
    public HttpResult detail(@Valid @RequestBody IdReqVo reqVo) throws SystemException {
        return HttpResult.ok(kwcContractLogisticsService.detail(reqVo.getId()));
    }

    /**
     * @desc: 发起签约
     * @param reqVo id
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("submit")
    public HttpResult submit(@Valid @RequestBody ContractLogisticsReqVo reqVo) throws SystemException {
        return HttpResult.ok(kwcContractLogisticsService.submit(reqVo));
    }

    /**
     * @desc: 修改草稿
     * @param reqVo id
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("update")
    public HttpResult update(@Valid @RequestBody ContractLogisticsReqVo reqVo) throws SystemException {
        kwcContractLogisticsService.update(reqVo);
        return HttpResult.ok();
    }


    /**
     * @desc: 手动完结
     * @param reqVo ids
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("complete")
    public HttpResult complete(@Valid @RequestBody CompleteReqVo reqVo) throws SystemException {
        kwcContractLogisticsService.complete(reqVo);
        return HttpResult.ok();
    }


    /**
     * @desc: 删除
     * @param reqVo ids
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("delete")
    public HttpResult delete(@Valid @RequestBody IdsReqVo reqVo) throws SystemException {
        kwcContractLogisticsService.delete(reqVo.getIds());
        return HttpResult.ok();
    }


    /**
     * @desc: 导出
     * @param reqVo 查询入参
     * @author: czh
     * @date 2023/7/17
     */
    @PostMapping("export")
    public void export(@Valid @RequestBody QueryListReqVo reqVo) throws SystemException {
        reqVo.setEntType(EntTypeEnum.LOGISTICS3.getCode());
        kwcContractLogisticsService.export(reqVo);
    }


    /**
     * @return HttpResult
     * @desc: 查询当前企业的托运合同
     * @author: czh
     * @date: 2023/7/18
     */
    @PostMapping("queryCurrentEntCheckedContractList")
    public HttpResult queryCurrentEntCheckedContractList() throws SystemException {
        return HttpResult.ok(kwcContractLogisticsService.queryCurrentEntCheckedContractList());
    }

    /**
     * @return HttpResult
     * @desc: 分组查询
     * @author: czh
     * @date: 2023/7/18
     */
    @PostMapping("findListGroup")
    public HttpResult findListGroup(@RequestBody QueryListReqVo reqVo) throws SystemException {
        reqVo.setEntType(EntTypeEnum.LOGISTICS3.getCode());
        return HttpResult.ok(kwcContractLogisticsService.findListGroup(reqVo));
    }


    @PostMapping("test")
    public HttpResult test() throws SystemException {
        kwcContractLogisticsService.test();
        return HttpResult.ok();
    }
}
